/* engine.c generated by valac 0.14.0, the Vala compiler
 * generated from engine.vala, do not modify */

/*
 * Copyright (C) 2011  Daiki Ueno
 * Copyright (C) 2011  Red Hat, Inc.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <ibus.h>
#include <ibusdrawing.h>
#include <ibus/ibuspanelextensions.h>
#include <gio/gio.h>
#include <stdio.h>


#define IBUS_DRAWING_TYPE_ENGINE (ibus_drawing_engine_get_type ())
#define IBUS_DRAWING_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), IBUS_DRAWING_TYPE_ENGINE, IBusDrawingEngine))
#define IBUS_DRAWING_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), IBUS_DRAWING_TYPE_ENGINE, IBusDrawingEngineClass))
#define IBUS_DRAWING_IS_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), IBUS_DRAWING_TYPE_ENGINE))
#define IBUS_DRAWING_IS_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), IBUS_DRAWING_TYPE_ENGINE))
#define IBUS_DRAWING_ENGINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), IBUS_DRAWING_TYPE_ENGINE, IBusDrawingEngineClass))

typedef struct _IBusDrawingEngine IBusDrawingEngine;
typedef struct _IBusDrawingEngineClass IBusDrawingEngineClass;
typedef struct _IBusDrawingEnginePrivate IBusDrawingEnginePrivate;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _IBusDrawingEngine {
	IBusEngine parent_instance;
	IBusDrawingEnginePrivate * priv;
};

struct _IBusDrawingEngineClass {
	IBusEngineClass parent_class;
};

struct _IBusDrawingEnginePrivate {
	GString* preedit;
	IBusDrawing* drawing;
};


static gpointer ibus_drawing_engine_parent_class = NULL;
extern IBusConfig* ibus_drawing_engine_config;
IBusConfig* ibus_drawing_engine_config = NULL;

GType ibus_drawing_engine_get_type (void) G_GNUC_CONST;
#define IBUS_DRAWING_ENGINE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), IBUS_DRAWING_TYPE_ENGINE, IBusDrawingEnginePrivate))
enum  {
	IBUS_DRAWING_ENGINE_DUMMY_PROPERTY
};
static void ibus_drawing_engine_real_enable (IBusEngine* base);
static void ibus_drawing_engine_real_disable (IBusEngine* base);
static void ibus_drawing_engine_real_focus_in (IBusEngine* base);
static void ibus_drawing_engine_real_focus_out (IBusEngine* base);
static void ibus_drawing_engine_real_set_cursor_location (IBusEngine* base, gint x, gint y, gint w, gint h);
static void ibus_drawing_engine_real_destroy (IBusObject* base);
IBusDrawingEngine* ibus_drawing_engine_new (void);
IBusDrawingEngine* ibus_drawing_engine_construct (GType object_type);
static GObject * ibus_drawing_engine_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void ibus_drawing_engine_finalize (GObject* obj);


static void ibus_drawing_engine_real_enable (IBusEngine* base) {
	IBusDrawingEngine * self;
	IBusDrawing* _tmp0_;
	self = (IBusDrawingEngine*) base;
	_tmp0_ = self->priv->drawing;
	ibus_panel_extension_show ((IBusPanelExtension*) _tmp0_);
	IBUS_ENGINE_CLASS (ibus_drawing_engine_parent_class)->enable (IBUS_ENGINE (self));
}


static void ibus_drawing_engine_real_disable (IBusEngine* base) {
	IBusDrawingEngine * self;
	IBusDrawing* _tmp0_;
	self = (IBusDrawingEngine*) base;
	_tmp0_ = self->priv->drawing;
	ibus_panel_extension_hide ((IBusPanelExtension*) _tmp0_);
	IBUS_ENGINE_CLASS (ibus_drawing_engine_parent_class)->disable (IBUS_ENGINE (self));
}


static void ibus_drawing_engine_real_focus_in (IBusEngine* base) {
	IBusDrawingEngine * self;
	IBusDrawing* _tmp0_;
	self = (IBusDrawingEngine*) base;
	_tmp0_ = self->priv->drawing;
	ibus_panel_extension_show ((IBusPanelExtension*) _tmp0_);
	IBUS_ENGINE_CLASS (ibus_drawing_engine_parent_class)->focus_in (IBUS_ENGINE (self));
}


static void ibus_drawing_engine_real_focus_out (IBusEngine* base) {
	IBusDrawingEngine * self;
	IBusDrawing* _tmp0_;
	self = (IBusDrawingEngine*) base;
	_tmp0_ = self->priv->drawing;
	ibus_panel_extension_hide ((IBusPanelExtension*) _tmp0_);
	IBUS_ENGINE_CLASS (ibus_drawing_engine_parent_class)->focus_out (IBUS_ENGINE (self));
}


static void ibus_drawing_engine_real_set_cursor_location (IBusEngine* base, gint x, gint y, gint w, gint h) {
	IBusDrawingEngine * self;
	IBusDrawing* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	self = (IBusDrawingEngine*) base;
	_tmp0_ = self->priv->drawing;
	_tmp1_ = x;
	_tmp2_ = y;
	_tmp3_ = w;
	_tmp4_ = h;
	ibus_panel_extension_set_cursor_location ((IBusPanelExtension*) _tmp0_, _tmp1_, _tmp2_, _tmp3_, _tmp4_);
	_tmp5_ = x;
	_tmp6_ = y;
	_tmp7_ = w;
	_tmp8_ = h;
	IBUS_ENGINE_CLASS (ibus_drawing_engine_parent_class)->set_cursor_location (IBUS_ENGINE (self), _tmp5_, _tmp6_, _tmp7_, _tmp8_);
}


static void ibus_drawing_engine_real_destroy (IBusObject* base) {
	IBusDrawingEngine * self;
	IBusDrawing* _tmp0_;
	self = (IBusDrawingEngine*) base;
	_tmp0_ = self->priv->drawing;
	ibus_panel_extension_hide ((IBusPanelExtension*) _tmp0_);
	IBUS_OBJECT_CLASS (ibus_drawing_engine_parent_class)->destroy ((IBusObject*) IBUS_ENGINE (self));
}


IBusDrawingEngine* ibus_drawing_engine_construct (GType object_type) {
	IBusDrawingEngine * self = NULL;
	self = (IBusDrawingEngine*) g_object_new (object_type, NULL);
	return self;
}


IBusDrawingEngine* ibus_drawing_engine_new (void) {
	return ibus_drawing_engine_construct (IBUS_DRAWING_TYPE_ENGINE);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static GObject * ibus_drawing_engine_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	IBusDrawingEngine * self;
	GError * _inner_error_ = NULL;
	parent_class = G_OBJECT_CLASS (ibus_drawing_engine_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = IBUS_DRAWING_ENGINE (obj);
	{
		GDBusConnection* _tmp0_ = NULL;
		GDBusConnection* _tmp1_;
		GDBusConnection* conn;
		GDBusConnection* _tmp2_;
		IBusDrawing* _tmp3_;
		IBusDrawing* _tmp4_;
		_tmp0_ = ibus_service_get_connection ((IBusService*) self);
		_tmp1_ = _g_object_ref0 (_tmp0_);
		conn = _tmp1_;
		_tmp2_ = conn;
		_tmp3_ = ibus_drawing_new (_tmp2_, &_inner_error_);
		_tmp4_ = _tmp3_;
		if (_inner_error_ != NULL) {
			_g_object_unref0 (conn);
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch0_g_io_error;
			}
			_g_object_unref0 (conn);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
		}
		_g_object_unref0 (self->priv->drawing);
		self->priv->drawing = _tmp4_;
		_g_object_unref0 (conn);
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		FILE* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp5_ = stderr;
		_tmp6_ = e;
		_tmp7_ = _tmp6_->message;
		fprintf (_tmp5_, "%s\n", _tmp7_);
		_g_error_free0 (e);
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	return obj;
}


static void ibus_drawing_engine_class_init (IBusDrawingEngineClass * klass) {
	ibus_drawing_engine_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (IBusDrawingEnginePrivate));
	IBUS_ENGINE_CLASS (klass)->enable = ibus_drawing_engine_real_enable;
	IBUS_ENGINE_CLASS (klass)->disable = ibus_drawing_engine_real_disable;
	IBUS_ENGINE_CLASS (klass)->focus_in = ibus_drawing_engine_real_focus_in;
	IBUS_ENGINE_CLASS (klass)->focus_out = ibus_drawing_engine_real_focus_out;
	IBUS_ENGINE_CLASS (klass)->set_cursor_location = ibus_drawing_engine_real_set_cursor_location;
	IBUS_OBJECT_CLASS (klass)->destroy = ibus_drawing_engine_real_destroy;
	G_OBJECT_CLASS (klass)->constructor = ibus_drawing_engine_constructor;
	G_OBJECT_CLASS (klass)->finalize = ibus_drawing_engine_finalize;
}


static void ibus_drawing_engine_instance_init (IBusDrawingEngine * self) {
	GString* _tmp0_;
	self->priv = IBUS_DRAWING_ENGINE_GET_PRIVATE (self);
	_tmp0_ = g_string_new ("");
	self->priv->preedit = _tmp0_;
}


static void ibus_drawing_engine_finalize (GObject* obj) {
	IBusDrawingEngine * self;
	self = IBUS_DRAWING_ENGINE (obj);
	_g_string_free0 (self->priv->preedit);
	_g_object_unref0 (self->priv->drawing);
	G_OBJECT_CLASS (ibus_drawing_engine_parent_class)->finalize (obj);
}


GType ibus_drawing_engine_get_type (void) {
	static volatile gsize ibus_drawing_engine_type_id__volatile = 0;
	if (g_once_init_enter (&ibus_drawing_engine_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (IBusDrawingEngineClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ibus_drawing_engine_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IBusDrawingEngine), 0, (GInstanceInitFunc) ibus_drawing_engine_instance_init, NULL };
		GType ibus_drawing_engine_type_id;
		ibus_drawing_engine_type_id = g_type_register_static (IBUS_TYPE_ENGINE, "IBusDrawingEngine", &g_define_type_info, 0);
		g_once_init_leave (&ibus_drawing_engine_type_id__volatile, ibus_drawing_engine_type_id);
	}
	return ibus_drawing_engine_type_id__volatile;
}



